﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Threading;
using System.Threading.Tasks;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 값 열거 가능형 구하기 (비동기) - GetValueEnumerableAsync(token)

        /// <summary>
        /// 값 열거 가능형 구하기 (비동기)
        /// </summary>
        /// <param name="token">취소 토큰</param>
        /// <returns>값 열거 가능형</returns>
        private static async IAsyncEnumerable<int> GetValueEnumerableAsync([EnumeratorCancellation] CancellationToken token = default)
        {
            for(int i = 0; i < 10; i++)
            {
                await Task.Delay(i * 100, token);

                yield return i;
            }
        }

        #endregion
        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        /// <returns>태스크</returns>
        private static async Task Main()
        {
            using CancellationTokenSource source = new CancellationTokenSource(3000);

            CancellationToken token = source.Token;

            await foreach(int value in GetValueEnumerableAsync().WithCancellation(token))
            {
                Console.WriteLine(value);
            }
        }

        #endregion
    }
}